#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <unistd.h>

#include "eme-32-aes.h"
#include "aes.h"

int main(void)
{
  uint8_t tmp[32];
  uint8_t C[512] = {0};
  uint8_t P[512] = {0};
  uint8_t P2[512] = {0};
  uint8_t T[16] = {0};
  int i;
  int j = 0;
  eme_ctx ctx;

  if (aes_test() != AES_OK) {
    fprintf(stderr, "aes self-test failed!\n");
    _exit(1);
  }
  if (read(0, tmp, 32) != 32) _exit(1);
  eme_aes_setup(&ctx, tmp, 32);
  if (read(0, P, 512) != 512) _exit(1);
  while (j < 1000000) {
    eme_aes_process(C, P, T, &ctx, aes_ecb_encrypt);
#if 0
    write(1, C, 512);
    /* encryption test vector start for all-zero PT,key,T:
     * 9F 2E 6C 3D AE CA E7 9E 88 39 B0 58 8F F3 78 CD
     * ...the rest in doc00011.doc
     */
#endif
    eme_aes_process(P2, C, T, &ctx, aes_ecb_decrypt);
#if 1
    if (memcmp(P, P2, 512)) {
      fprintf(stderr, "block encrypt/decrypt failed after %d loops\n", j);
      _exit(1);
    }
#endif

    /* increase tweak or change plaintext, or both */
#if 1
    for (i = 0; i < 16; i++) if (++T[i]) break;
#endif
#if 0
    for (i = 0; i < 512; i++) if (++P[i]) break;
#endif

    j++;
  }

  return 0;
}

